package com.unissoft.mqtt.controller;

import com.alibaba.fastjson2.JSON;
import com.unissoft.mqtt.model.MqttParams;
import com.unissoft.mqtt.outbound.MqttMessageSender;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @author qingsong.han
 * @description: 消息测试
 * @create 2023-02-14 13:49
 */
@Slf4j
@RestController
@RequestMapping("/mqtt")
public class MqttController {

    private final MqttMessageSender mqttMessageSender;

    @Autowired
    public MqttController(MqttMessageSender mqttMessageSender) {
        this.mqttMessageSender = mqttMessageSender;
    }

    /**
     * TODO 测试发送mqtt消息
     *
     * @param params 消息内容
     * @return ResultView
     */
    @PostMapping("/sendMessage")
    public String send(@RequestBody MqttParams params) {
        try {
            this.mqttMessageSender.sendToMqtt(params.getTopic(), params.getQos(), params.getPayload());
        } catch (Exception e) {
            e.printStackTrace();
            return "601";
        }
        log.info("发送mqtt消息完成: {}", JSON.toJSONString(params));
        return "200";
    }

}
