package com.unissoft.mqtt.inbound;

import com.alibaba.fastjson2.JSON;
import lombok.extern.slf4j.Slf4j;
import org.springframework.lang.NonNull;
import org.springframework.messaging.Message;
import org.springframework.messaging.MessageHandler;
import org.springframework.messaging.MessagingException;
import org.springframework.stereotype.Component;


/**
 * @author qingsong.han
 * @description: mqtt订阅消息处理
 * @create 2023-02-14 11:21
 */
@Slf4j
@Component
public class MqttMessageReceiver implements MessageHandler {

    /**
     * @param message 消息
     * @throws MessagingException
     */
    @Override
    public void handleMessage(@NonNull Message<?> message) throws MessagingException {
        log.info("接收到 mqtt消息: {}", JSON.toJSONString(message));
    }

}
