package com.unissoft.mqtt.service.impl;

import com.alibaba.fastjson2.JSON;
import com.unissoft.mqtt.model.MqttPayload;
import com.unissoft.mqtt.service.MqttMessageService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.messaging.Message;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import java.util.List;
import java.util.Map;

/**
 * @author qingsong.han
 * @description:
 * @create 2023-02-14 17:41
 */
@Slf4j
@Service
public class MqttMessageServiceImpl implements MqttMessageService {

    @Override
    public void uploadData(Message<?> message) {
        /*
         * message内容
         * topic 可以设置为识别标识 例如:机构编码唯一标识
         */
        String payload = String.valueOf(message.getPayload());
        // log.info("payload: {}", payload);
        // headers
        Map<String, Object> mqttHeaders = message.getHeaders();
        // 数据刷新频繁,防止系统崩溃使用try catch
        try {
            // topic 获取订阅主题
            String subscribeTopic = (String) mqttHeaders.get("mqtt_receivedTopic");
            if (!StringUtils.isEmpty(subscribeTopic)) {
                // payload
                MqttPayload mqttPayload = JSON.parseObject(payload, MqttPayload.class);
                // 获取点位参数
                List data = mqttPayload.getData();
                log.info("data: {}", data);
            } else {
                // 自定义异常
                throw new IllegalArgumentException("MQTT topic 解析错误");
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

    }

}
